{
    "$graph": [
        {
            "label": "Prepare user input",
            "class": "Workflow",
            "doc": "Prepare user input for  NCBI-PGAP pipeline",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/fasta"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/ignore_all_errors"
                },
                {
                    "type": "File",
                    "id": "#main/submol"
                },
                {
                    "type": "File",
                    "id": "#main/taxon_db"
                }
            ],
            "steps": [
                {
                    "run": "#file2int.cwl",
                    "in": [
                        {
                            "source": "#main/pgapx_yaml_ctl/taxid",
                            "id": "#main/file2int_taxid/input"
                        }
                    ],
                    "out": [
                        "#main/file2int_taxid/value"
                    ],
                    "id": "#main/file2int_taxid"
                },
                {
                    "run": "#file2string.cwl",
                    "in": [
                        {
                            "source": "#main/pgapx_yaml_ctl/input_asn_type",
                            "id": "#main/file2string_input_asn_type/input"
                        }
                    ],
                    "out": [
                        "#main/file2string_input_asn_type/value"
                    ],
                    "id": "#main/file2string_input_asn_type"
                },
                {
                    "run": "#file2string.cwl",
                    "in": [
                        {
                            "source": "#main/pgapx_yaml_ctl/output_ltp",
                            "id": "#main/file2string_ltp/input"
                        }
                    ],
                    "out": [
                        "#main/file2string_ltp/value"
                    ],
                    "id": "#main/file2string_ltp"
                },
                {
                    "run": "#asn_cleanup.cwl",
                    "in": [
                        {
                            "source": "#main/pgapx_yaml_ctl/output_annotation",
                            "id": "#main/initial_cleanup/inp_annotation"
                        },
                        {
                            "default": "cleaned_input.asn",
                            "id": "#main/initial_cleanup/out_annotation_name"
                        },
                        {
                            "default": "text",
                            "id": "#main/initial_cleanup/outformat"
                        },
                        {
                            "default": "text",
                            "id": "#main/initial_cleanup/serial"
                        },
                        {
                            "source": "#main/file2string_input_asn_type/value",
                            "id": "#main/initial_cleanup/type1"
                        }
                    ],
                    "out": [
                        "#main/initial_cleanup/annotation"
                    ],
                    "id": "#main/initial_cleanup"
                },
                {
                    "label": "pgapx_yaml_ctl",
                    "run": "#pgapx_yaml_ctl.cwl",
                    "in": [
                        {
                            "source": "#main/ignore_all_errors",
                            "id": "#main/pgapx_yaml_ctl/ignore_all_errors"
                        },
                        {
                            "source": "#main/yaml2json/output",
                            "id": "#main/pgapx_yaml_ctl/input"
                        },
                        {
                            "source": "#main/fasta",
                            "id": "#main/pgapx_yaml_ctl/input_fasta"
                        },
                        {
                            "source": "#main/taxon_db",
                            "id": "#main/pgapx_yaml_ctl/taxon_db"
                        }
                    ],
                    "out": [
                        "#main/pgapx_yaml_ctl/output_annotation",
                        "#main/pgapx_yaml_ctl/output_ltp",
                        "#main/pgapx_yaml_ctl/input_asn_type",
                        "#main/pgapx_yaml_ctl/taxid"
                    ],
                    "id": "#main/pgapx_yaml_ctl"
                },
                {
                    "run": {
                        "class": "ExpressionTool",
                        "inputs": [
                            {
                                "type": "File",
                                "id": "#main/type_based_splitter/8083d9c6-ab6a-4924-b81a-76d77f7969aa/input"
                            },
                            {
                                "type": "string",
                                "id": "#main/type_based_splitter/8083d9c6-ab6a-4924-b81a-76d77f7969aa/input_asn_type"
                            }
                        ],
                        "outputs": [
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "id": "#main/type_based_splitter/8083d9c6-ab6a-4924-b81a-76d77f7969aa/output_entries"
                            },
                            {
                                "type": [
                                    "null",
                                    "File"
                                ],
                                "id": "#main/type_based_splitter/8083d9c6-ab6a-4924-b81a-76d77f7969aa/output_seq_submit"
                            }
                        ],
                        "expression": "${ if ( inputs.input_asn_type == 'seq-entry' ) { return { 'output_entries': inputs.input, 'output_seq_submit': null } } if ( inputs.input_asn_type == 'seq-submit' ) { return { 'output_entries': null, 'output_seq_submit': inputs.input } } }",
                        "id": "#main/type_based_splitter/8083d9c6-ab6a-4924-b81a-76d77f7969aa"
                    },
                    "in": [
                        {
                            "source": "#main/initial_cleanup/annotation",
                            "id": "#main/type_based_splitter/input"
                        },
                        {
                            "source": "#main/file2string_input_asn_type/value",
                            "id": "#main/type_based_splitter/input_asn_type"
                        }
                    ],
                    "out": [
                        "#main/type_based_splitter/output_entries",
                        "#main/type_based_splitter/output_seq_submit"
                    ],
                    "id": "#main/type_based_splitter"
                },
                {
                    "label": "yaml2json",
                    "run": "#yaml2json.cwl",
                    "in": [
                        {
                            "source": "#main/submol",
                            "id": "#main/yaml2json/input"
                        }
                    ],
                    "out": [
                        "#main/yaml2json/output"
                    ],
                    "id": "#main/yaml2json"
                }
            ],
            "id": "#main",
            "outputs": [
                {
                    "type": "string",
                    "outputSource": "#main/file2string_input_asn_type/value",
                    "id": "#main/input_asn_type"
                },
                {
                    "type": "string",
                    "outputSource": "#main/file2string_ltp/value",
                    "id": "#main/locus_tag_prefix"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/type_based_splitter/output_entries",
                    "id": "#main/output_entries"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/type_based_splitter/output_seq_submit",
                    "id": "#main/output_seq_submit"
                },
                {
                    "type": "File",
                    "outputSource": "#main/yaml2json/output",
                    "id": "#main/submol_block_json"
                },
                {
                    "type": "int",
                    "outputSource": "#main/file2int_taxid/value",
                    "id": "#main/taxid"
                }
            ]
        },
        {
            "label": "asn_cleanup",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": "asn_cleanup",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-i"
                    },
                    "id": "#asn_cleanup.cwl/inp_annotation"
                },
                {
                    "type": "string",
                    "default": "cleaned-annotation.asn",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#asn_cleanup.cwl/out_annotation_name"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "text",
                    "inputBinding": {
                        "prefix": "-outformat"
                    },
                    "id": "#asn_cleanup.cwl/outformat"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "binary",
                    "inputBinding": {
                        "prefix": "-serial"
                    },
                    "id": "#asn_cleanup.cwl/serial"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-type",
                        "valueFrom": "${ if ( inputs.type1 != 'seq-entry' ) return inputs.type1; else return null; }"
                    },
                    "id": "#asn_cleanup.cwl/type1"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.out_annotation_name)"
                    },
                    "id": "#asn_cleanup.cwl/annotation"
                }
            ],
            "id": "#asn_cleanup.cwl"
        },
        {
            "class": "ExpressionTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "loadContents": true
                    },
                    "id": "#file2int.cwl/input"
                }
            ],
            "expression": "${ return { \"value\": parseInt(inputs.input.contents) }; }\n",
            "outputs": [
                {
                    "type": "int",
                    "id": "#file2int.cwl/value"
                }
            ],
            "id": "#file2int.cwl"
        },
        {
            "class": "ExpressionTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "loadContents": true
                    },
                    "id": "#file2string.cwl/input"
                }
            ],
            "expression": "${ return { \"value\": String(inputs.input.contents).trim() }; }\n",
            "outputs": [
                {
                    "type": "string",
                    "id": "#file2string.cwl/value"
                }
            ],
            "id": "#file2string.cwl"
        },
        {
            "label": "pgapx_yaml_ctl",
            "doc": "Converts input JSON file to ASN.1 template",
            "class": "CommandLineTool",
            "baseCommand": "pgapx_yaml_ctl",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "default": "JSON",
                    "inputBinding": {
                        "prefix": "-ifmt"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/ifmt"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-ignore-all-errors"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/ignore_all_errors"
                },
                {
                    "type": "File",
                    "doc": "JSON file with submission and molecule specification",
                    "inputBinding": {
                        "prefix": "-input"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/input"
                },
                {
                    "type": "File",
                    "doc": "FASTA file with user provided headers and user provided prokaryota genome",
                    "inputBinding": {
                        "prefix": "-input-fasta"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/input_fasta"
                },
                {
                    "type": "string",
                    "default": "JSON",
                    "inputBinding": {
                        "prefix": "-ofmt"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/ofmt"
                },
                {
                    "type": "string",
                    "default": "input.asn",
                    "inputBinding": {
                        "prefix": "-output-annotation"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/output_annotation_name"
                },
                {
                    "type": "string",
                    "default": "input_asn_type.txt",
                    "inputBinding": {
                        "prefix": "-output-asn-type"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/output_input_asn_type_name"
                },
                {
                    "type": "string",
                    "default": "genome.ltp.txt",
                    "inputBinding": {
                        "prefix": "-output-ltp"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/output_ltp_name"
                },
                {
                    "type": "string",
                    "default": "taxid.txt",
                    "inputBinding": {
                        "prefix": "-output-taxid"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/output_taxid_name"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-taxon-db"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/taxon_db"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_input_asn_type_name)"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/input_asn_type"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_annotation_name)"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/output_annotation"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_ltp_name)"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/output_ltp"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_taxid_name)"
                    },
                    "id": "#pgapx_yaml_ctl.cwl/taxid"
                }
            ],
            "id": "#pgapx_yaml_ctl.cwl"
        },
        {
            "label": "yaml2json",
            "class": "CommandLineTool",
            "baseCommand": "yaml2json.py",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#yaml2json.cwl/input"
                },
                {
                    "type": "string",
                    "default": "submol.json",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#yaml2json.cwl/output_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#yaml2json.cwl/output"
                }
            ],
            "id": "#yaml2json.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
